Attribute VB_Name = "Geometry"
Option Explicit

Public Const PI = 3.14159265
' Return the arccosine of X.
Function Acos(ByVal X As Single) As Single
    Acos = Atn(-X / Sqr(-X * X + 1)) + 2 * Atn(1)
End Function

' Return the angle ABC.
' Return a value between PI and -PI.
Public Function GetAngle(ByVal Ax As Single, ByVal Ay As Single, ByVal Bx As Single, ByVal By As Single, ByVal Cx As Single, ByVal Cy As Single) As Single
Dim side_a As Single
Dim side_b As Single
Dim side_c As Single

    ' Get the lengths of the triangle's sides.
    side_a = Sqr((Bx - Cx) ^ 2 + (By - Cy) ^ 2)
    side_b = Sqr((Ax - Cx) ^ 2 + (Ay - Cy) ^ 2)
    side_c = Sqr((Ax - Bx) ^ 2 + (Ay - By) ^ 2)

    ' Calculate angle B between sides ab and bc.
    GetAngle = Acos((side_b ^ 2 - side_a ^ 2 - side_c ^ 2) / (-2 * side_a * side_c))
End Function

